
//  CalendarsStandard.java  Copyright (c) Kari Laitinen

//  http://www.naturalprogramming.com

//  2012-11-21  File created.
//  2012-11-21  Last modification.

import java.util.Calendar ;
import java.util.GregorianCalendar ;

class  EnglishCalendar
{
   protected  int  this_year ;
   protected  int  this_month ;

   protected  String[]  names_of_months ;
   protected  String    week_description ;

   public EnglishCalendar() {}

   public EnglishCalendar( int given_year, int given_month )
   {
      String[]  english_names_of_months  =  

         { "January", "February", "March", "April",
           "May", "June", "July", "August",
           "September", "October", "November", "December" } ;

      String  english_week_description  =

          " Week   Mon  Tue  Wed  Thu  Fri  Sat  Sun" ;

      names_of_months   =  english_names_of_months ;

      week_description  =  english_week_description ;

      this_year   =  given_year  ;
      this_month  =  given_month ;
   }


   public void print()
   {
      Calendar a_day_in_this_month  =
                  new  GregorianCalendar( this_year, this_month - 1, 1 ) ;

      a_day_in_this_month.setFirstDayOfWeek( Calendar.MONDAY ) ;

      // In the standard Java calendar-related classes
      // Calendar.SUNDAY == 1, Calendar.MONDAY == 2, ...., Calendar.SATURDAY == 7

      int day_of_week_index   =  0 ;

      int day_of_week_of_first_day  =
                          a_day_in_this_month.get( Calendar.DAY_OF_WEEK ) ;

      System.out.print(
            "\n\n   "  +  names_of_months[ this_month - 1 ]
         +  "  "  +  this_year  +  "\n\n"  +  week_description   +  "\n\n" );

      System.out.printf( "%4d  ",  a_day_in_this_month.get( Calendar.WEEK_OF_YEAR ) ) ;

      // The first week of a month is often an incomplete week, 
      // i.e., the first part of week belongs to the previous
      // month. In place of the days that belong to the previous
      // month we print just spaces.

      // N.B. There is always at least one day in the first week of a month.

      while ( day_of_week_index < 6 &&
              day_of_week_index != ( day_of_week_of_first_day - 2 ) )
      {
         System.out.print( "     " )  ;
         day_of_week_index  ++ ;
      }

      while ( ( this_month - 1 )  ==  a_day_in_this_month.get( Calendar.MONTH ) )
      {
         if ( day_of_week_index  >=  7 )
         {
            System.out.printf( "\n%4d  ",
                               a_day_in_this_month.get( Calendar.WEEK_OF_YEAR ) ) ;

            day_of_week_index  =  0 ;
         }

         System.out.printf( "%5d", a_day_in_this_month.get( Calendar.DAY_OF_MONTH ) ) ;

         a_day_in_this_month.add( Calendar.DAY_OF_MONTH, 1 ) ;

         day_of_week_index  ++  ;
      }

      System.out.print( "\n" ) ;
   }
}



class  SpanishCalendar  extends  EnglishCalendar
{
   public SpanishCalendar( int given_year, int given_month )
   {
      String[]  spanish_names_of_months  =


         { "Enero", "Febrero", "Marzo", "Abril",
           "Mayo", "Junio", "Julio", "Agosto",
           "Septiembre", "Octubre", "Noviembre", "Deciembre" } ;

      String   spanish_week_description  =

           "Semana  Lun  Mar  Mie  Jue  Vie  Sab  Dom" ;

      names_of_months   =  spanish_names_of_months ;
      week_description  =  spanish_week_description ;

      this_year   =  given_year  ;
      this_month  =  given_month ;
   }
}


class  CalendarsStandard
{
   public static void main( String[] not_in_use )
   {
      EnglishCalendar an_english_calendar = new EnglishCalendar( 2012, 11 ) ;

      an_english_calendar.print() ;

      SpanishCalendar a_spanish_calendar  = new SpanishCalendar( 2013, 9 ) ;

      a_spanish_calendar.print() ;
   }
}


